﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace AutoDialer
{
    class cFileCSV
    {
        string m_sFilePath;
         
        public cFileCSV(string sFilePath)
        {
            m_sFilePath = sFilePath;
        }

        public bool GetDataCSV(ref List<string> objListPhoneNo, ref List<string> objListPhoneStatus, ref List<string> objListDTMF, ref List<string> objListDuration)
        {
            if (m_sFilePath == "")
                return false;

            try
            {
                var objStreamReader = new StreamReader(File.OpenRead(m_sFilePath));

                while (!objStreamReader.EndOfStream)
                {
                    var line = objStreamReader.ReadLine();
                    var values = line.Split(',');

                    if (values[0].ToString().Length == 0)
                        values[0] = "  ";

                    if (values[1].ToString().Length == 0)
                        values[1] = "  ";

                    if (values[2].ToString().Length == 0)
                        values[2] = "  ";

                    if (values[3].ToString().Length == 0)
                        values[3] = "  ";

                    objListPhoneNo.Add(values[0].ToString());
                    objListPhoneStatus.Add(values[1].ToString());
                    objListDTMF.Add(values[2].ToString());
                    objListDuration.Add(values[3].ToString());
                }

                objStreamReader.Close();
            }

            catch(Exception objException)
            {
                return false;
            }

            return true;
        }

        public bool WriteDataCSV(List<string> objListPhoneNo, List<string> objListPhoneStatus, List<string> objListDTMF, List<string> objListDuration)
        {
            if (m_sFilePath == "")
                return false;

            if (objListPhoneNo.Count != objListPhoneStatus.Count())
                return false;

            try
            {
                using(var objStreamWriter = new StreamWriter(m_sFilePath))
                {
                    for (int nIndex = 0; nIndex < objListPhoneNo.Count; nIndex++)
                    {
                        string sline = string.Format("{0},{1},{2},{3}", objListPhoneNo[nIndex], objListPhoneStatus[nIndex], objListDTMF[nIndex], objListDuration[nIndex]);
                        objStreamWriter.WriteLine(sline);
                        objStreamWriter.Flush();
                    }
                }
            }

            catch(Exception objException)
            {
                return false;
            }

            return true;
        }

    }
}
