﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Data;

namespace BasicIVR
{
    class CGenFileLocation
    {
        public string GenRecordingFilePath(int nSessionId, string sDefaultPath)
        {
            if(sDefaultPath.Length == 0)
                return "";

            string sFolderPath = GetFullPath(sDefaultPath);

            if (sFolderPath.Length == 0)
                return "";

            //sFileName = string.Format("{0}.wav", nSessionId);

            string sFilePath = string.Format("{0}\\{1}.wav", sFolderPath, nSessionId);

            return sFilePath;
        }

        private string GetFullPath(string sDefaultPath)
        {
            DirectoryInfo objDirInfo;

            if (!Directory.Exists(sDefaultPath))
            {
                objDirInfo = Directory.CreateDirectory(sDefaultPath);

                if (!objDirInfo.Exists)
                    return "";
            }

            DateTime objDateTime = DateTime.Now;
            string sFullPath = string.Format("{0}\\{1}\\{2}\\{3}", sDefaultPath, objDateTime.Year, objDateTime.Month, objDateTime.Day);

            objDirInfo = Directory.CreateDirectory(sFullPath);

            if (!objDirInfo.Exists)
                return "";

            return sFullPath;
        }
    }
}
