﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BasicIVR
{
    class cVaxCallSession : object
    {
        public int m_nSessionId;

        public string m_sPhoneNo;
        public string m_sStatus;

        public UInt32 m_nPhoneNoId;

        private UInt32 m_nStartTime;
        private UInt32 m_nEndTime;

        private UInt32 m_nDuration;
        private Boolean m_bConnected;

        cVaxAccessAudioPCM m_objAccessPCM;
        cVaxDetectAudioVAD m_objDetectVAD;

        public cVaxCallSession()
        {
            m_nPhoneNoId = 0;

            m_nStartTime = 0;
            m_nEndTime = 0;
            m_nDuration = 0;
            
            m_bConnected = false;

            m_objAccessPCM = new cVaxAccessAudioPCM();
            m_objDetectVAD = new cVaxDetectAudioVAD();
        }

        public void StartCall()
        {
            TimeSpan t = DateTime.UtcNow - new DateTime(1970, 1, 1);
            m_nStartTime = (UInt32) t.TotalSeconds;
        }

        public void EndCall()
        {
            TimeSpan t = DateTime.UtcNow - new DateTime(1970, 1, 1);
            m_nEndTime = (UInt32)t.TotalSeconds;

            m_nDuration = m_nEndTime - m_nStartTime;
        }

        public String GetDuration()
        {
            DateTime epoch = new DateTime(1970, 1, 1);
            DateTime obj = epoch.AddSeconds(m_nDuration);

            String sHour = obj.Hour.ToString();
            String sMin = obj.Minute.ToString();
            String sSec = obj.Second.ToString();
            
            if(sHour.Length == 1)
                sHour = "0" + sHour;

            if(sMin.Length == 1)
                sMin = "0" + sMin;

            if(sSec.Length == 1)
                sSec = "0" + sSec;

            /*
            if(obj.Hour >= 0 && obj.Hour <= 9)
                sHour = "0" + obj.Hour.ToString();

            if (obj.Minute >= 0 && obj.Minute <= 9)
                sMin = "0" + obj.Minute.ToString();

            if (obj.Second >= 0 && obj.Second <= 9)
                sSec = "0" + obj.Second.ToString();
             * */

            String sTime = String.Format("{0}:{1}:{2}", sHour, sMin, sSec);
            return sTime;
        }

        public void SetConnected()
        {
            m_bConnected = true;
        }

        public Boolean IsConnected()
        {
            return m_bConnected;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////
        public void OnCallSessionConnected(int nSessionId, int nChannelId)
        {
            m_objAccessPCM.OnCallSessionConnected(nSessionId, nChannelId);
            m_objDetectVAD.OnCallSessionConnected(nSessionId, nChannelId);
        }

        public void OnCallSessionClosed(int nSessionId, int nChannelId, int nReasonCode)
        {
            m_objAccessPCM.OnCallSessionClosed(nSessionId);
            m_objDetectVAD.OnCallSessionClosed(nSessionId);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////
        public void OnCallSessionAccessAudioPCM(int nSessionId, int nAccessType, Byte[] aDataPCM, int nSizePCM)
        {
            m_objAccessPCM.OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM);
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////
        public void OnCallSessionMediaDetectStartedVAD(int nSessionId, int nChannelId)
        {
            m_objDetectVAD.OnCallSessionMediaDetectStartedVAD(nSessionId, nChannelId);
        }

        public void OnCallSessionMediaDetectCompletedVAD(int nSessionId, int nChannelId, Byte[] aDataPCM, int nSizePCM, int nTypePCM)
        {
            m_objDetectVAD.OnCallSessionMediaDetectCompletedVAD(nSessionId, nChannelId, aDataPCM, nSizePCM, nTypePCM);
        }

        public void OnCallSessionMediaDetectExpiredVAD(int nSessionId, int nChannelId)
        {
            m_objDetectVAD.OnCallSessionMediaDetectExpiredVAD(nSessionId, nChannelId);
        }
    }
}
